import { JSONObject, MetadataKind } from '../utils/types';
import { Signed, SignedOptions } from './base';
import { MetaFile } from './file';
type MetaFileMap = Record<string, MetaFile>;
export interface SnapshotOptions extends SignedOptions {
    meta?: MetaFileMap;
}
export declare class Snapshot extends Signed {
    readonly type = MetadataKind.Snapshot;
    readonly meta: MetaFileMap;
    constructor(opts: SnapshotOptions);
    equals(other: Snapshot): boolean;
    toJSON(): JSONObject;
    static fromJSON(data: JSONObject): Snapshot;
}
export {};
