import { BaseFetcher } from './fetcher';
import { TargetFile } from './models/file';
import { Config } from './utils/config';
interface UpdaterOptions {
    metadataDir: string;
    metadataBaseUrl: string;
    targetDir?: string;
    targetBaseUrl?: string;
    fetcher?: BaseFetcher;
    config?: Config;
}
export declare class Updater {
    private dir;
    private metadataBaseUrl;
    private targetDir?;
    private targetBaseUrl?;
    private trustedSet;
    private config;
    private fetcher;
    constructor(options: UpdaterOptions);
    refresh(): Promise<void>;
    private loadLocalMetadata;
    private loadRoot;
    private loadTimestamp;
    private loadSnapshot;
    private loadTargets;
    getTargetInfo(targetPath: string): Promise<TargetFile | undefined>;
    private preorderDepthFirstWalk;
    findCachedTarget(targetInfo: TargetFile, filePath?: string): Promise<string | undefined>;
    private generateTargetPath;
    downloadTarget(targetInfo: TargetFile, filePath?: string, targetBaseUrl?: string): Promise<string>;
    private persistMetadata;
}
export {};
